## xenium 0.0.1+ds

=== debian/changelog ===
xenium (0.0.1+ds-2) unstable; urgency=medium

  * Fix FTBFS with GCC 10

 -- Balint Reczey <rbalint@ubuntu.com>  Wed, 04 Nov 2020 22:03:39 +0100

xenium (0.0.1+ds-1) unstable; urgency=medium

  * Initial release (Closes: #965347)

 -- Steffen Moeller <moeller@debian.org>  Mon, 20 Jul 2020 00:37:21 +0200

## xenium 0.0.2%2Bds

=== debian/changelog ===
xenium (0.0.2+ds-9) unstable; urgency=medium

  * Team upload.
  * Fix build with CMake 4
    Closes: #1113641
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 20 Oct 2025 14:53:40 +0200

xenium (0.0.2+ds-8) unstable; urgency=medium

  * Team upload.
  * Fix watch file

 -- Andreas Tille <tille@debian.org>  Tue, 06 Dec 2022 20:12:23 +0100

xenium (0.0.2+ds-7) unstable; urgency=medium

  * Team upload.

  [ Adrian Bunk ]
  * Don't build the tests with -Werror
    Closes: #1016263

  [ Andreas Tille ]
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 14 Sep 2022 07:57:21 +0200

xenium (0.0.2+ds-6) unstable; urgency=medium

  * Team upload.
  * Builds on amd64 only

 -- Andreas Tille <tille@debian.org>  Wed, 22 Dec 2021 16:51:28 +0100

xenium (0.0.2+ds-5) unstable; urgency=medium

  * Team Upload.
  * Add patch to fix GCC-11 FTBFS (Closes: #997269)

 -- Nilesh Patra <nilesh@debian.org>  Sun, 24 Oct 2021 02:11:28 +0530

xenium (0.0.2+ds-4) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * Apply multi-arch hints.
    + libxenium-doc: Add Multi-Arch: foreign.

 -- Andreas Tille <tille@debian.org>  Wed, 29 Sep 2021 18:31:19 +0200

xenium (0.0.2+ds-3) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Team upload.

  [ Juhani Numminen ]
  * Do not enable Thread Sanitizer in debian/rules, It is now enabled via
    debian/patches/detect-thread-sanitizer.patch

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 30 Dec 2020 18:46:06 +0100

xenium (0.0.2+ds-2) unstable; urgency=medium

  * Team upload.
  * Architecture: any-amd64, any-i386, sparc64 (see #976481)
  * Standards-Version: 4.5.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sat, 05 Dec 2020 20:29:15 +0100

xenium (0.0.2+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Nilesh Patra <npatra974@gmail.com>  Fri, 13 Nov 2020 03:19:52 +0530

## xenium 0.0.2+ds

=== CMakeLists.txt ===
project(xenium)
cmake_minimum_required(VERSION 3.0)

include(gtest.cmake)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

enable_testing()

find_package(Threads REQUIRED)
find_package(Doxygen)

option(BUILD_DOCUMENTATION "Create the HTML based documentation (requires Doxygen)" ${DOXYGEN_FOUND})

file(GLOB_RECURSE XENIUM_FILES xenium/*.hpp)

file(GLOB_RECURSE TEST_FILES test/*.cpp)

file(GLOB_RECURSE BENCHMARK_FILES benchmarks/*.cpp)

include_directories(
	.
	${GTEST_INCLUDE_DIRS}
	./3rdParty/json/include
	./3rdParty/config/include
)

add_executable(gtest ${TEST_FILES} ${XENIUM_FILES})

add_executable(benchmark ${BENCHMARK_FILES} ${XENIUM_FILES})

target_link_libraries(gtest googletest)

if(CMAKE_THREAD_LIBS_INIT)
	target_link_libraries(gtest "${CMAKE_THREAD_LIBS_INIT}")
	target_link_libraries(benchmark "${CMAKE_THREAD_LIBS_INIT}")
endif()

if(WITH_LIBCDS)
	find_package(LibCDS CONFIG REQUIRED)
	target_link_libraries(benchmark LibCDS::cds)
	target_compile_definitions(benchmark PRIVATE WITH_LIBCDS CDS_THREADING_CXX11)
endif()

if(MSVC)
	target_compile_options(gtest PRIVATE /bigobj /W4)# /WX)
	target_compile_options(benchmark PRIVATE /bigobj)# /W4 /WX)
else()
	target_compile_options(gtest PRIVATE -Wall -Wextra -Werror -Wno-error=cpp)
	target_compile_options(benchmark PRIVATE -Wall -Wextra -Wno-error=cpp)
endif()

if(CMAKE_BUILD_TYPE MATCHES Debug)
	add_definitions(-DDEBUG)
elseif(CMAKE_BUILD_TYPE MATCHES RelWithDebug)
	add_definitions(-DNDEBUG)
elseif(CMAKE_BUILD_TYPE MATCHES Release)
	add_definitions(-DNDEBUG)
endif()

if(BUILD_DOCUMENTATION)
	if(NOT DOXYGEN_FOUND)
		message(FATAL_ERROR "Doxygen is needed to build the documentation.")
	endif()

	add_custom_target(doc
			COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc
			COMMENT "Generating API documentation with Doxygen"
			VERBATIM)
endif()

add_test(AllTests gtest)

=== debian/control ===
Source: xenium
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>
Build-Depends: debhelper-compat (= 13),
               libboost-dev,
# OPTIONAL     libcds-dev,
               tao-json-dev,
               tao-config-dev,
               cmake,
               doxygen,
               googletest <!nocheck>
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/xenium
Vcs-Git: https://salsa.debian.org/med-team/xenium.git
Homepage: https://github.com/mpoeter/xenium/
Rules-Requires-Root: no

Package: libxenium-dev
Architecture: any-amd64
Section: libdevel
Depends: ${misc:Depends}
Description: concurrent data structures and memory reclamation algorithms
 xenium is a header-only library that provides a collection of concurrent
 data structures and memory reclamation algorithms. The data structures
 are parameterized so that they can be used with various reclamation
 schemes (similar to how the STL allows customization of allocators).
 .
  * header only
  * highly customizable
  * no initialization code needed
  * supports dynamic number of threads (no fixed compile time
    specification)

Package: libxenium-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Enhances: libxenium-dev
Multi-Arch: foreign
Description: HTML documentation for the xenium library
 xenium is a header-only library that provides a collection of concurrent
 data structures and memory reclamation algorithms. The data structures
 are parameterized so that they can be used with various reclamation
 schemes (similar to how the STL allows customization of allocators).
 .
  * header only
  * highly customizable
  * no initialization code needed
  * supports dynamic number of threads (no fixed compile time
    specification)
 .
 This package contains the documentation for libxenium as well as some
 benchmarking and testing code.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE="RelWithDebug" # -DWITH_LIBCDS="1"

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C obj-$$(dpkg-architecture -qDEB_TARGET_GNU_TYPE) doc

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "I: Executing benchmark - who knows how to execute it properly?"
	obj-$$(dpkg-architecture -qDEB_TARGET_GNU_TYPE)/benchmark || true
	echo "I: gtest"
	obj-$$(dpkg-architecture -qDEB_TARGET_GNU_TYPE)/gtest
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/html/

=== debian/watch ===
version=4

opts="repacksuffix=+ds,dversionmangle=auto,filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/mpoeter/xenium/tags .*/v?@ANY_VERSION@\.tar\.gz

# opts="mode=git,pretty=0.0+git%cd.%h,repacksuffix=+ds,dversionmangle=auto" https://github.com/mpoeter/xenium.git HEAD
